openapi: 3.0.0 info: title: InfluxDB Cloud Serverless HTTP API description: > The InfluxDB HTTP API provides a programmatic interface for writing, querying, and managing data stored in InfluxDB Cloud Serverless (powered by the InfluxDB 3 storage engine). Access the InfluxDB HTTP API using the `/api/v2/` or InfluxDB v1 endpoints. ### InfluxDB v2-compatible endpoints InfluxDB v2-compatible endpoints work with InfluxDB Cloud Serverless and with InfluxDB 2.x client libraries and third-party integrations. The following v2-compatible endpoints are supported for Cloud Serverless: - `/api/v2/write` — write data - `/api/v2/authorizations` — manage API tokens - `/api/v2/buckets` — manage buckets - `/api/v2/orgs` — manage organizations ### InfluxDB v1-compatible endpoints InfluxDB v1-compatible endpoints work with InfluxDB Cloud Serverless and with InfluxDB 1.x client libraries and third-party integrations. - `/write` — write data - `/query` — query data with InfluxQL ### Other endpoints Other endpoints in this reference are for the InfluxDB Cloud (TSM) API. These endpoints may be accessible but are not supported or recommended for use with InfluxDB Cloud Serverless, which is powered by the InfluxDB 3 storage engine. For Cloud Serverless-specific functionality, see the [InfluxDB Cloud Serverless documentation](https://docs.influxdata.com/influxdb3/cloud-serverless/). license: name: MIT url: https://opensource.org/licenses/MIT version: '' contact: name: InfluxData url: https://www.influxdata.com email: support@influxdata.com x-influxdata-short-title: HTTP API x-influxdata-short-description: >- The InfluxDB HTTP API provides a programmatic interface for writing, querying, and managing data stored in InfluxDB Cloud Serverless (powered by the InfluxDB 3 storage engine). servers: - url: https://{baseurl} description: InfluxDB 3 Cloud Serverless API URL variables: baseurl: enum: - us-east-1-1.aws.cloud2.influxdata.com default: us-east-1-1.aws.cloud2.influxdata.com description: InfluxDB 3 Cloud Serverless URL security: - TokenAuthentication: [] tags: - description: >- InfluxDB Cloud Serverless supports a subset of the InfluxDB v2 API. Other endpoints in this reference are for the InfluxDB Cloud (TSM) API — they may be accessible, but are not supported or recommended for use with InfluxDB Cloud Serverless, which is powered by the InfluxDB 3 storage engine. ### Write data InfluxDB Cloud Serverless provides the following HTTP API endpoints for writing data: - **Recommended**: `/api/v2/write` endpoint for new write workloads or for bringing existing InfluxDB v2 write workloads. - `/write` endpoint for bringing existing InfluxDB v1 write workloads. Both endpoints accept line protocol format and process data in the same way. ### Query data InfluxDB Cloud Serverless provides the following protocols for executing a query: - **Recommended**: _Flight+gRPC_ request that contains an SQL or InfluxQL query. - HTTP API `/query` request that contains an InfluxQL query. Use this endpoint when bringing existing InfluxDB v1 query workloads. ### Management endpoints Use the following endpoints to manage Cloud Serverless resources: - API tokens (authorizations) — create and manage API tokens - Buckets — create and manage storage buckets - Organizations — view and manage organizations - Accounts — manage account information ### InfluxDB v2 compatibility The `/api/v2/write` endpoint works with the Token authentication scheme and existing InfluxDB 2.x tools and code. ### InfluxDB v1 compatibility The `/write` and `/query` endpoints work with InfluxDB 1.x username/password authentication and existing InfluxDB 1.x tools and code. name: API compatibility x-traitTag: true x-related: - title: Write data href: https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/ - title: Get started querying InfluxDB href: >- https://docs.influxdata.com/influxdb3/cloud-serverless/get-started/query/ - title: Manage API tokens href: >- https://docs.influxdata.com/influxdb3/cloud-serverless/security/tokens/ - title: Manage buckets href: https://docs.influxdata.com/influxdb3/cloud-serverless/admin/buckets/ - title: Use the v2 HTTP API with Cloud Serverless href: >- https://docs.influxdata.com/influxdb3/cloud-serverless/guides/api-compatibility/v2/ - title: Use the v1 HTTP API with Cloud Serverless href: >- https://docs.influxdata.com/influxdb3/cloud-serverless/guides/api-compatibility/v1/ - description: >- Use one of the following schemes to authenticate to the InfluxDB Cloud Serverless API: - Token authentication - Basic authentication name: Authentication x-traitTag: true - description: >- Create and manage API token authorizations that grant read and write permissions to InfluxDB 3 Cloud Serverless organization resources. name: Authorizations (API tokens) x-related: - title: Manage API tokens href: >- https://docs.influxdata.com/influxdb3/cloud-serverless/security/tokens/ - description: >- Create and manage named storage locations (buckets) in InfluxDB 3 Cloud Serverless, each with a configurable retention period. name: Buckets x-related: - title: Manage buckets href: https://docs.influxdata.com/influxdb3/cloud-serverless/admin/buckets/ - description: >- Most InfluxDB Cloud Serverless API endpoints require parameters in the request--for example, to specify the bucket or organization. The following table shows common query parameters used by many InfluxDB Cloud Serverless API endpoints. | Query parameter | Value type | Description | |:----------------|:-----------|:---------------------------------------------| | `bucket` | string | The bucket name. | | `bucketID` | string | The bucket ID. | | `org` | string | The organization name. | | `orgID` | string | The organization ID. | | `precision` | string | Timestamp precision: `ns`, `us`, `ms`, `s`. | | `db` | string | The database (for v1-compatible endpoints). | name: Common parameters x-traitTag: true - description: >- Create and manage database retention policy (DBRP) mappings for InfluxDB Cloud Serverless. DBRP mappings associate v1-compatible database and retention policy combinations with Cloud Serverless buckets, enabling queries and writes using InfluxDB v1 API endpoints. name: DBRPs x-related: - title: Use v1 API compatibility endpoints href: >- https://docs.influxdata.com/influxdb3/cloud-serverless/guides/api-compatibility/v1/ - description: >- InfluxDB Cloud Serverless API endpoints use standard HTTP request and response headers. The following table shows common headers used by many InfluxDB Cloud Serverless API endpoints. Some endpoints may use other headers for functions specific to those endpoints--for example, the write endpoints accept the `Content-Encoding` header to indicate that line protocol is compressed in the request body. | Header | Value type | Description | |:-------------------|:-----------|:------------------------------------------------------| | `Accept` | string | The content type that the client can understand. | | `Authorization` | string | The authorization scheme and credential. | | `Content-Encoding` | string | Compression applied to the request body (e.g., gzip). | | `Content-Length` | integer | The size of the entity-body, in bytes. | | `Content-Type` | string | The format of the data in the request body. | name: Headers x-traitTag: true - name: Limits description: >- Retrieve rate limits and usage quotas for an InfluxDB 3 Cloud Serverless organization. - description: >- View and manage InfluxDB 3 Cloud Serverless organizations, which are workspaces that group users, buckets, and resources. name: Organizations x-related: - title: View and manage organizations href: https://docs.influxdata.com/influxdb3/cloud-serverless/admin/ - description: >- List endpoints in the InfluxDB Cloud Serverless API support pagination via query parameters. Use these parameters to page through large result sets. | Query parameter | Value type | Description | |:----------------|:-----------|:----------------------------------------------------| | `limit` | integer | Maximum number of records to return (default: 20). | | `offset` | integer | Number of records to skip before returning results. | | `after` | string | Return records created after the specified record ID. | | `descending` | boolean | Sort results in descending order. | List responses include pagination metadata (such as total count or links to the next page) to help navigate through result pages. name: Pagination x-traitTag: true - description: >- Query data stored in InfluxDB 3 Cloud Serverless using InfluxQL via the v1-compatible `/query` endpoint, or using SQL and InfluxQL via Flight+gRPC clients. name: Query data x-related: - title: Get started querying InfluxDB href: >- https://docs.influxdata.com/influxdb3/cloud-serverless/get-started/query/ - title: Execute queries href: >- https://docs.influxdata.com/influxdb3/cloud-serverless/query-data/execute-queries/ - description: >- Get started writing and querying data with the InfluxDB 3 Cloud Serverless API. name: Quick start x-traitTag: true - description: >- InfluxDB Cloud Serverless API endpoints return standard HTTP status codes. The following table summarizes the most common response codes. | Status code | Meaning | |:------------|:------------------------------------------------------------------------| | `200 OK` | Success. | | `201 Created` | The resource was created. | | `204 No Content` | Success with no response body (typically after write or delete). | | `400 Bad Request` | Request parameters or body are malformed or invalid. | | `401 Unauthorized` | Missing or invalid credentials. | | `403 Forbidden` | Credentials lack permission for the requested resource. | | `404 Not Found` | The requested resource does not exist. | | `413 Payload Too Large` | Request body exceeds the maximum allowed size. | | `422 Unprocessable Entity` | Request body is well-formed but semantically invalid. | | `429 Too Many Requests` | Rate limit exceeded. | | `500 Internal Server Error` | Unexpected server error. | | `503 Service Unavailable` | Server is overloaded or under maintenance. | name: Response codes x-traitTag: true - description: >- The InfluxDB 3 Cloud Serverless API supports create, read, update, and delete operations on resources. Most endpoints follow standard HTTP method conventions: | Operation | HTTP Method | Description | |:----------|:------------|:------------| | **Write** | `POST` | Send data or create a resource. | | **Read** | `GET` | Retrieve a resource or list resources. | | **Update** | `PUT`, `PATCH` | Replace or modify an existing resource. | | **Delete** | `DELETE` | Remove a resource. | name: Supported operations x-traitTag: true - name: Usage description: >- Retrieve usage metrics and cardinality data for an InfluxDB 3 Cloud Serverless organization. - description: >- Write time series data to InfluxDB 3 Cloud Serverless buckets using the v2-compatible `/api/v2/write` endpoint or the v1-compatible `/write` endpoint with line protocol. name: Write data x-related: - title: Write data href: https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/ paths: /api/v2/authorizations: get: description: > Lists authorizations. To limit which authorizations are returned, pass query parameters in your request. If no query parameters are passed, InfluxDB returns all authorizations. InfluxDB 3 Cloud Serverless doesn't expose [API token](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#token) values in `GET /api/v2/authorizations` responses; returns `token: redacted` for all authorizations. #### Required permissions To retrieve an authorization, the request must use an API token that has the following permissions: - `read-authorizations` - `read-user` for the user that the authorization is scoped to #### Related guides - [View tokens](https://docs.influxdata.com/influxdb3/cloud-serverless/security/tokens/view-tokens/) operationId: GetAuthorizations parameters: - $ref: '#/components/parameters/TraceSpan' - description: > A user ID. Only returns authorizations scoped to the specified [user](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#user). in: query name: userID schema: type: string - description: > A user name. Only returns authorizations scoped to the specified [user](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#user). in: query name: user schema: type: string - description: >- An organization ID. Only returns authorizations that belong to the specified [organization](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#organization). in: query name: orgID schema: type: string - description: > An organization name. Only returns authorizations that belong to the specified [organization](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#organization). in: query name: org schema: type: string - description: > An API [token](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#token) value. Specifies an authorization by its `token` property value and returns the authorization. #### Limitations - The parameter is non-repeatable. If you specify more than one, only the first one is used. If a resource with the specified property value doesn't exist, then the response body contains an empty list. in: query name: token schema: type: string responses: '200': content: application/json: schema: $ref: '#/components/schemas/Authorizations' description: > Success. The response body contains a list of authorizations. If the response body is missing authorizations that you expect, check that the API token used in the request has `read-user` permission for the users (`userID` property value) in those authorizations. '400': $ref: '#/components/responses/GeneralServerError' description: Invalid request '401': $ref: '#/components/responses/AuthorizationError' '500': $ref: '#/components/responses/InternalServerError' default: $ref: '#/components/responses/GeneralServerError' description: Unexpected error summary: List authorizations tags: - Authorizations (API tokens) post: description: > Creates an authorization and returns the authorization with the generated API [token](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#token). Use this endpoint to create an authorization, which generates an API token with permissions to `read` or `write` to a specific resource or `type` of resource. The API token is the authorization's `token` property value. To follow best practices for secure API token generation and retrieval, InfluxDB enforces access restrictions on API tokens. - InfluxDB allows access to the API token value immediately after the authorization is created. - You can’t change access (read/write) permissions for an API token after it’s created. - Tokens stop working when the user who created the token is deleted. We recommend the following for managing your tokens: - Create a generic user to create and manage tokens for writing data. - Store your tokens in a secure password vault for future access. #### Required permissions - `write-authorizations` - `write-user` for the user that the authorization is scoped to #### Related guides - [Create a token](https://docs.influxdata.com/influxdb3/cloud-serverless/security/tokens/create-token/) operationId: PostAuthorizations parameters: - $ref: '#/components/parameters/TraceSpan' requestBody: content: application/json: examples: AuthorizationPostRequest: $ref: '#/components/examples/AuthorizationPostRequest' AuthorizationWithResourcePostRequest: $ref: '#/components/examples/AuthorizationWithResourcePostRequest' AuthorizationWithUserPostRequest: $ref: '#/components/examples/AuthorizationWithUserPostRequest' schema: $ref: '#/components/schemas/AuthorizationPostRequest' description: The authorization to create. required: true responses: '201': content: application/json: schema: $ref: '#/components/schemas/Authorization' description: > Success. The authorization is created. The response body contains the authorization. '400': $ref: '#/components/responses/GeneralServerError' description: Invalid request '401': $ref: '#/components/responses/AuthorizationError' '500': $ref: '#/components/responses/InternalServerError' default: $ref: '#/components/responses/GeneralServerError' description: Unexpected error summary: Create an authorization tags: - Authorizations (API tokens) /api/v2/authorizations/{authID}: delete: description: | Deletes an authorization. Use the endpoint to delete an API token. If you want to disable an API token instead of delete it, update the authorization's status to `inactive`. operationId: DeleteAuthorizationsID parameters: - $ref: '#/components/parameters/TraceSpan' - description: An authorization ID. Specifies the authorization to delete. in: path name: authID required: true schema: type: string responses: '204': description: Success. The authorization is deleted. '400': content: application/json: examples: notFound: summary: | The specified resource ID is invalid. value: code: invalid message: id must have a length of 16 bytes schema: $ref: '#/components/schemas/Error' description: | Bad request. '401': $ref: '#/components/responses/AuthorizationError' '404': content: application/json: examples: notFound: summary: | The requested authorization doesn't exist. value: code: not found message: authorization not found schema: $ref: '#/components/schemas/Error' description: | Not found. '500': $ref: '#/components/responses/InternalServerError' default: $ref: '#/components/responses/GeneralServerError' description: Unexpected error summary: Delete an authorization tags: - Authorizations (API tokens) get: description: > Retrieves an authorization. Use this endpoint to retrieve information about an API token, including the token's permissions and the user that the token is scoped to. #### Related guides - [View tokens](https://docs.influxdata.com/influxdb3/cloud-serverless/security/tokens/view-tokens/) operationId: GetAuthorizationsID parameters: - $ref: '#/components/parameters/TraceSpan' - description: An authorization ID. Specifies the authorization to retrieve. in: path name: authID required: true schema: type: string responses: '200': content: application/json: schema: $ref: '#/components/schemas/Authorization' description: Success. The response body contains the authorization. '400': content: application/json: examples: notFound: summary: | The specified resource ID is invalid. value: code: invalid message: id must have a length of 16 bytes schema: $ref: '#/components/schemas/Error' description: | Bad request. '401': $ref: '#/components/responses/AuthorizationError' '404': content: application/json: examples: notFound: summary: | The requested authorization doesn't exist. value: code: not found message: authorization not found schema: $ref: '#/components/schemas/Error' description: | Not found. '500': $ref: '#/components/responses/InternalServerError' default: $ref: '#/components/responses/GeneralServerError' description: Unexpected error summary: Retrieve an authorization tags: - Authorizations (API tokens) patch: description: > Updates an authorization. Use this endpoint to set an API token's status to be _active_ or _inactive_. InfluxDB rejects requests that use inactive API tokens. operationId: PatchAuthorizationsID parameters: - $ref: '#/components/parameters/TraceSpan' - description: An authorization ID. Specifies the authorization to update. in: path name: authID required: true schema: type: string requestBody: content: application/json: schema: $ref: '#/components/schemas/AuthorizationUpdateRequest' description: In the request body, provide the authorization properties to update. required: true responses: '200': content: application/json: schema: $ref: '#/components/schemas/Authorization' description: Success. The response body contains the updated authorization. default: $ref: '#/components/responses/GeneralServerError' description: Unexpected error summary: Update an API token to be active or inactive tags: - Authorizations (API tokens) /api/v2/buckets: get: description: > Lists [buckets](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#bucket). InfluxDB retrieves buckets owned by the [organization](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#organization) associated with the authorization ([API token](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#token)). To limit which buckets are returned, pass query parameters in your request. If no query parameters are passed, InfluxDB returns all buckets up to the default `limit`. #### Required permissions | Action | Permission required | |:--------------------------|:--------------------| | Retrieve _user buckets_ | `read-buckets` | | Retrieve [_system buckets_](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/internals/system-buckets/) | `read-orgs` | #### Related Guides - [Manage buckets](https://docs.influxdata.com/influxdb3/cloud-serverless/admin/buckets/) operationId: GetBuckets parameters: - $ref: '#/components/parameters/TraceSpan' - $ref: '#/components/parameters/Offset' - $ref: '#/components/parameters/Limit' - $ref: '#/components/parameters/After' - description: > An organization name. #### InfluxDB 3 Cloud Serverless - Doesn't use the `org` parameter or `orgID` parameter. - Lists buckets for the organization associated with the authorization (API token). in: query name: org schema: type: string - description: > An organization ID. #### InfluxDB 3 Cloud Serverless - Doesn't use the `org` parameter or `orgID` parameter. - Lists buckets for the organization associated with the authorization (API token). in: query name: orgID schema: type: string - description: | A bucket name. Only returns buckets with the specified name. in: query name: name schema: type: string - description: | A bucket ID. Only returns the bucket with the specified ID. in: query name: id schema: type: string responses: '200': content: application/json: examples: successResponse: value: buckets: - createdAt: '2022-03-15T17:22:33.72617939Z' description: System bucket for monitoring logs id: 77ca9dace40a9bfc labels: [] links: labels: /api/v2/buckets/77ca9dace40a9bfc/labels members: /api/v2/buckets/77ca9dace40a9bfc/members org: /api/v2/orgs/INFLUX_ORG_ID owners: /api/v2/buckets/77ca9dace40a9bfc/owners self: /api/v2/buckets/77ca9dace40a9bfc write: /api/v2/write?org=ORG_ID&bucket=77ca9dace40a9bfc name: _monitoring orgID: INFLUX_ORG_ID retentionRules: - everySeconds: 604800 type: expire schemaType: implicit type: system updatedAt: '2022-03-15T17:22:33.726179487Z' links: self: >- /api/v2/buckets?descending=false&limit=20&name=_monitoring&offset=0&orgID=ORG_ID schema: $ref: '#/components/schemas/Buckets' description: | Success. The response body contains a list of `buckets`. '401': $ref: '#/components/responses/AuthorizationError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: List buckets tags: - Buckets x-codeSamples: - label: 'cURL: filter buckets by name' lang: Shell source: > curl --request GET "http://localhost:8086/api/v2/buckets?name=_monitoring" \ --header "Authorization: Token INFLUX_TOKEN" \ --header "Accept: application/json" \ --header "Content-Type: application/json" post: description: > Creates a [bucket](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#bucket) and returns the bucket resource. The default data [retention period](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#retention-period) is 30 days. #### Limitations - InfluxDB Cloud Free Plan allows users to create up to two buckets. Exceeding the bucket quota will result in an HTTP `403` status code. For additional information regarding InfluxDB Cloud offerings, see [InfluxDB Cloud Pricing](https://www.influxdata.com/influxdb-cloud-pricing/). #### Related Guides - [Create a bucket](https://docs.influxdata.com/influxdb3/cloud-serverless/admin/buckets/create-bucket/) - [Create bucket CLI reference](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/cli/influx/bucket/create) operationId: PostBuckets parameters: - $ref: '#/components/parameters/TraceSpan' requestBody: content: application/json: schema: $ref: '#/components/schemas/PostBucketRequest' description: The bucket to create. required: true responses: '201': content: application/json: examples: successResponse: value: createdAt: '2022-08-03T23:04:41.073704121Z' description: A bucket holding air sensor data id: 37407e232b3911d8 labels: [] links: labels: /api/v2/buckets/37407e232b3911d8/labels members: /api/v2/buckets/37407e232b3911d8/members org: /api/v2/orgs/INFLUX_ORG_ID owners: /api/v2/buckets/37407e232b3911d8/owners self: /api/v2/buckets/37407e232b3911d8 write: /api/v2/write?org=INFLUX_ORG_ID&bucket=37407e232b3911d8 name: air_sensor orgID: INFLUX_ORG_ID retentionRules: - everySeconds: 2592000 type: expire schemaType: implicit type: user updatedAt: '2022-08-03T23:04:41.073704228Z' schema: $ref: '#/components/schemas/Bucket' description: | Success. The bucket is created. '400': content: application/json: schema: $ref: '#/components/schemas/Error' description: | Bad request. '401': $ref: '#/components/responses/AuthorizationError' '403': content: application/json: examples: quotaExceeded: summary: Bucket quota exceeded value: code: forbidden message: creating bucket would exceed quota schema: $ref: '#/components/schemas/Error' description: | Forbidden. The bucket quota is exceeded. headers: X-Platform-Error-Code: description: | The reason for the error. schema: example: forbidden type: string '422': content: application/json: schema: $ref: '#/components/schemas/Error' description: | Unprocessable Entity. The request body failed validation. '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Create a bucket tags: - Buckets x-codeSamples: - label: 'cURL: create a bucket with retention period' lang: Shell source: | curl --request POST "http://localhost:8086/api/v2/buckets \ --header "Authorization: Token INFLUX_TOKEN" \ --header "Accept: application/json" \ --header "Content-Type: application/json" \ --data '{ "name": "air_sensor", "description": "A bucket holding air sensor data", "orgID": "INFLUX_ORG_ID", "retentionRules": [ { "type": "expire", "everySeconds": 2592000, } ] }' - label: cURL lang: Shell source: '' /api/v2/buckets/{bucketID}: delete: description: > Deletes a bucket and all associated records. #### InfluxDB 3 Cloud Serverless - Does the following when you send a delete request: 1. Validates the request and queues the delete. 2. Returns an HTTP `204` status code if queued; _error_ otherwise. 3. Handles the delete asynchronously. #### Limitations - Only one bucket can be deleted per request. #### Related Guides - [Manage buckets](https://docs.influxdata.com/influxdb3/cloud-serverless/admin/buckets/) operationId: DeleteBucketsID parameters: - $ref: '#/components/parameters/TraceSpan' - description: | Bucket ID. The ID of the bucket to delete. in: path name: bucketID required: true schema: type: string responses: '204': description: | Success. #### InfluxDB 3 Cloud Serverless - The bucket is queued for deletion. '400': content: application/json: examples: invalidID: summary: | Invalid ID. value: code: invalid message: id must have a length of 16 bytes schema: $ref: '#/components/schemas/Error' description: | Bad Request. '401': $ref: '#/components/responses/AuthorizationError' '404': content: application/json: examples: notFound: summary: | The requested bucket was not found. value: code: not found message: bucket not found schema: $ref: '#/components/schemas/Error' description: | Not found. Bucket not found. '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Delete a bucket tags: - Buckets x-codeSamples: - label: cURL lang: Shell source: > curl --request DELETE "http://localhost:8086/api/v2/buckets/BUCKET_ID" \ --header "Authorization: Token INFLUX_TOKEN" \ --header 'Accept: application/json' get: description: | Retrieves a bucket. Use this endpoint to retrieve information for a specific bucket. operationId: GetBucketsID parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the bucket to retrieve. in: path name: bucketID required: true schema: type: string responses: '200': content: application/json: examples: successResponse: value: createdAt: '2022-08-03T23:04:41.073704121Z' description: bucket for air sensor data id: 37407e232b3911d8 labels: [] links: labels: /api/v2/buckets/37407e232b3911d8/labels members: /api/v2/buckets/37407e232b3911d8/members org: /api/v2/orgs/INFLUX_ORG_ID owners: /api/v2/buckets/37407e232b3911d8/owners self: /api/v2/buckets/37407e232b3911d8 write: /api/v2/write?org=INFLUX_ORG_ID&bucket=37407e232b3911d8 name: air-sensor orgID: bea7ea952287f70d retentionRules: - everySeconds: 2592000 type: expire schemaType: implicit type: user updatedAt: '2022-08-03T23:04:41.073704228Z' schema: $ref: '#/components/schemas/Bucket' description: | Success. The response body contains the bucket information. '401': $ref: '#/components/responses/AuthorizationError' '404': content: application/json: examples: notFound: summary: | The requested bucket wasn't found. value: code: not found message: bucket not found schema: $ref: '#/components/schemas/Error' description: | Not found. Bucket not found. '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Retrieve a bucket tags: - Buckets patch: description: > Updates a bucket. Use this endpoint to update properties (`name`, `description`, and `retentionRules`) of a bucket. #### InfluxDB 3 Cloud Serverless - Requires the `retentionRules` property in the request body. If you don't provide `retentionRules`, InfluxDB responds with an HTTP `403` status code. #### Related Guides - [Update a bucket](https://docs.influxdata.com/influxdb3/cloud-serverless/admin/buckets/update-bucket/) operationId: PatchBucketsID parameters: - $ref: '#/components/parameters/TraceSpan' - description: The bucket ID. in: path name: bucketID required: true schema: type: string requestBody: content: application/json: schema: $ref: '#/components/schemas/PatchBucketRequest' description: The bucket update to apply. required: true responses: '200': content: application/json: examples: successResponse: value: createdAt: '2022-08-03T23:04:41.073704121Z' description: bucket holding air sensor data id: 37407e232b3911d8 labels: [] links: labels: /api/v2/buckets/37407e232b3911d8/labels members: /api/v2/buckets/37407e232b3911d8/members org: /api/v2/orgs/INFLUX_ORG_ID owners: /api/v2/buckets/37407e232b3911d8/owners self: /api/v2/buckets/37407e232b3911d8 write: /api/v2/write?org=INFLUX_ORG_ID&bucket=37407e232b3911d8 name: air_sensor orgID: INFLUX_ORG_ID retentionRules: - everySeconds: 2592000 type: expire schemaType: implicit type: user updatedAt: '2022-08-07T22:49:49.422962913Z' schema: $ref: '#/components/schemas/Bucket' description: An updated bucket '400': content: application/json: examples: invalidJSONStringValue: description: > If the request body contains invalid JSON, InfluxDB returns `invalid` with detail about the problem. summary: Invalid JSON value: code: invalid message: >- invalid json: invalid character '\'' looking for beginning of value schema: $ref: '#/components/schemas/Error' description: | Bad Request. '401': $ref: '#/components/responses/AuthorizationError' '403': content: application/json: examples: invalidRetention: summary: > The retention policy provided exceeds the max retention for the organization. value: code: forbidden message: provided retention exceeds orgs maximum retention duration schema: $ref: '#/components/schemas/Error' description: | Forbidden. '404': content: application/json: examples: notFound: summary: | The requested bucket wasn't found. value: code: not found message: bucket not found schema: $ref: '#/components/schemas/Error' description: | Not found. Bucket not found. '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Update a bucket tags: - Buckets x-codeSamples: - label: cURL lang: Shell source: > curl --request PATCH "http://localhost:8086/api/v2/buckets/BUCKET_ID \ --header "Authorization: Token INFLUX_TOKEN" \ --header "Accept: application/json" \ --header "Content-Type: application/json" \ --data '{ "name": "air_sensor", "description": "bucket holding air sensor data", "retentionRules": [ { "type": "expire", "everySeconds": 2592000 } ] }' /api/v2/buckets/{bucketID}/labels: get: description: > Lists all labels for a bucket. Labels are objects that contain `labelID`, `name`, `description`, and `color` key-value pairs. They may be used for grouping and filtering InfluxDB resources. Labels are also capable of grouping across different resources--for example, you can apply a label named `air_sensor` to a bucket and a task to quickly organize resources. #### Related guides - Use the `/api/v2/labels` InfluxDB API endpoint to retrieve and manage labels. - [Manage buckets](https://docs.influxdata.com/influxdb3/cloud-serverless/admin/buckets/) operationId: GetBucketsIDLabels parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the bucket to retrieve labels for. in: path name: bucketID required: true schema: type: string responses: '200': content: application/json: examples: successResponse: value: labels: - id: 09cbd068e7ebb000 name: production_buckets orgID: INFLUX_ORG_ID links: self: /api/v2/labels schema: $ref: '#/components/schemas/LabelsResponse' description: | Success. The response body contains a list of all labels for the bucket. '400': $ref: '#/components/responses/BadRequestError' '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: List all labels for a bucket tags: - Buckets post: description: > Adds a label to a bucket and returns the new label information. Labels are objects that contain `labelID`, `name`, `description`, and `color` key-value pairs. They may be used for grouping and filtering across one or more kinds of **resources**--for example, you can apply a label named `air_sensor` to a bucket and a task to quickly organize resources. #### Limitations - Before adding a label to a bucket, you must create the label if you haven't already. To create a label with the InfluxDB API, send a `POST` request to the `/api/v2/labels` endpoint. #### Related guides - Use the `/api/v2/labels` InfluxDB API endpoint to retrieve and manage labels. - [Manage labels in the InfluxDB UI](https://docs.influxdata.com/influxdb3/cloud-serverless/visualize-data/labels/) operationId: PostBucketsIDLabels parameters: - $ref: '#/components/parameters/TraceSpan' - description: | Bucket ID. The ID of the bucket to label. in: path name: bucketID required: true schema: type: string requestBody: content: application/json: schema: $ref: '#/components/schemas/LabelMapping' description: An object that contains a _`labelID`_ to add to the bucket. required: true responses: '201': content: application/json: examples: successResponse: value: label: id: 09cbd068e7ebb000 name: production_buckets orgID: INFLUX_ORG_ID links: self: /api/v2/labels schema: $ref: '#/components/schemas/LabelResponse' description: | Success. The response body contains the label information. '400': $ref: '#/components/responses/BadRequestError' examples: invalidRequest: summary: The `labelID` is missing from the request body. value: code: invalid message: label id is required '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '422': content: application/json: examples: conflictingResource: summary: | Label already exists on the resource. value: code: conflict message: Cannot add label, label already exists on resource schema: $ref: '#/components/schemas/Error' description: | Unprocessable entity. Label already exists on the resource. '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Add a label to a bucket tags: - Buckets x-codeSamples: - label: cURL lang: Shell source: > curl --request POST "http://localhost:8086/api/v2/buckets/BUCKETS_ID/labels \ --header "Authorization: Token INFLUX_TOKEN" \ --header "Accept: application/json" \ --header "Content-Type: application/json" \ --data '{ "labelID": "09cbd068e7ebb000" }' /api/v2/buckets/{bucketID}/labels/{labelID}: delete: operationId: DeleteBucketsIDLabelsID parameters: - $ref: '#/components/parameters/TraceSpan' - description: The bucket ID. in: path name: bucketID required: true schema: type: string - description: The ID of the label to delete. in: path name: labelID required: true schema: type: string responses: '204': description: Delete has been accepted '404': content: application/json: schema: $ref: '#/components/schemas/Error' description: Bucket not found default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Delete a label from a bucket tags: - Buckets /api/v2/buckets/{bucketID}/members: get: description: > Lists all users for a bucket. InfluxDB [users](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#user) have permission to access InfluxDB. [Members](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#member) are users in an organization with access to the specified resource. Use this endpoint to retrieve all users with access to a bucket. operationId: GetBucketsIDMembers parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the bucket to retrieve users for. in: path name: bucketID required: true schema: type: string responses: '200': content: application/json: examples: successResponse: value: links: self: /api/v2/buckets/37407e232b3911d8/members users: - id: 791df274afd48a83 links: self: /api/v2/users/791df274afd48a83 name: example_user_1 role: member status: active - id: 09cfb87051cbe000 links: self: /api/v2/users/09cfb87051cbe000 name: example_user_2 role: owner status: active schema: $ref: '#/components/schemas/ResourceMembers' description: | Success. The response body contains a list of all users for the bucket. '400': $ref: '#/components/responses/BadRequestError' '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: List all users with member privileges for a bucket tags: - Buckets post: description: > Add a user to a bucket and return the new user information. InfluxDB [users](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#user) have permission to access InfluxDB. [Members](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#member) are users in an organization. Use this endpoint to give a user member privileges to a bucket. #### Related guides - [Manage users](https://docs.influxdata.com/influxdb3/cloud-serverless/users/) - [Manage members](https://docs.influxdata.com/influxdb3/cloud-serverless/organizations/members/) operationId: PostBucketsIDMembers parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the bucket to retrieve users for. in: path name: bucketID required: true schema: type: string requestBody: content: application/json: schema: $ref: '#/components/schemas/AddResourceMemberRequestBody' description: A user to add as a member to the bucket. required: true responses: '201': content: application/json: examples: successResponse: value: id: 09cfb87051cbe000 links: self: /api/v2/users/09cfb87051cbe000 name: example_user_1 role: member status: active schema: $ref: '#/components/schemas/ResourceMember' description: | Success. The response body contains the user information. '400': $ref: '#/components/responses/BadRequestError' examples: invalidRequest: summary: The user `id` is missing from the request body. value: code: invalid message: user id missing or invalid '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Add a member to a bucket tags: - Buckets x-codeSamples: - label: cURL lang: Shell source: > curl --request POST "http://localhost:8086/api/v2/buckets/BUCKET_ID/members \ --header "Authorization: Token INFLUX_API_TOKEN" \ --header "Accept: application/json" \ --header "Content-Type: application/json" \ --data '{ "id": "09cfb87051cbe000" } /api/v2/buckets/{bucketID}/members/{userID}: delete: description: > Removes a member from a bucket. Use this endpoint to remove a user's member privileges from a bucket. This removes the user's `read` and `write` permissions for the bucket. #### Related guides - [Manage users](https://docs.influxdata.com/influxdb3/cloud-serverless/users/) - [Manage members](https://docs.influxdata.com/influxdb3/cloud-serverless/organizations/members/) operationId: DeleteBucketsIDMembersID parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the user to remove. in: path name: userID required: true schema: type: string - description: | The ID of the bucket to remove a user from. in: path name: bucketID required: true schema: type: string responses: '204': description: | Success. The user is no longer a member of the bucket. '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Remove a member from a bucket tags: - Buckets /api/v2/buckets/{bucketID}/owners: get: description: > Lists all [owners](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#owner) of a bucket. Bucket owners have permission to delete buckets and remove user and member permissions from the bucket. InfluxDB 3 Cloud Serverless uses `/api/v2/authorizations` to assign resource permissions; doesn't use `owner` and `member` roles. #### Limitations - Owner permissions are separate from API token permissions. - Owner permissions are used in the context of the InfluxDB UI. #### Required permissions - `read-orgs INFLUX_ORG_ID` *`INFLUX_ORG_ID`* is the ID of the organization that you want to retrieve a list of owners for. #### Related endpoints - Authorizations (API tokens) operationId: GetBucketsIDOwners parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the bucket to retrieve owners for. in: path name: bucketID required: true schema: type: string responses: '200': content: application/json: examples: successResponse: value: links: self: /api/v2/buckets/BUCKET_ID/owners users: - id: d88d182d91b0950f links: self: /api/v2/users/d88d182d91b0950f name: example-owner role: owner status: active schema: $ref: '#/components/schemas/ResourceOwners' description: | Success. The response body contains a list of all owners for the bucket. '400': $ref: '#/components/responses/BadRequestError' '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: List all owners of a bucket tags: - Buckets post: description: > Adds an owner to a bucket and returns the [owners](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#owner) with role and user detail. Use this endpoint to create a _resource owner_ for the bucket. Bucket owners have permission to delete buckets and remove user and member permissions from the bucket. InfluxDB 3 Cloud Serverless uses `/api/v2/authorizations` to assign resource permissions; doesn't use `owner` and `member` roles. #### Limitations - Owner permissions are separate from API token permissions. - Owner permissions are used in the context of the InfluxDB UI. #### Required permissions - `write-orgs INFLUX_ORG_ID` *`INFLUX_ORG_ID`* is the ID of the organization that you want to add an owner for. #### Related endpoints - Authorizations (API tokens) #### Related guides - [Manage users](https://docs.influxdata.com/influxdb3/cloud-serverless/users/) operationId: PostBucketsIDOwners parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the bucket to add an owner for. in: path name: bucketID required: true schema: type: string requestBody: content: application/json: examples: successResponse: value: id: d88d182d91b0950f links: self: /api/v2/users/d88d182d91b0950f name: example-user role: owner status: active schema: $ref: '#/components/schemas/AddResourceMemberRequestBody' description: A user to add as an owner for the bucket. required: true responses: '201': content: application/json: schema: $ref: '#/components/schemas/ResourceOwner' description: | Created. The bucket `owner` role is assigned to the user. The response body contains the resource owner with role and user detail. '400': $ref: '#/components/responses/BadRequestError' examples: invalidRequest: summary: The user `id` is missing from the request body. value: code: invalid message: user id missing or invalid '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Add an owner to a bucket tags: - Buckets x-codeSamples: - label: cURL lang: Shell source: > curl --request POST "http://localhost:8086/api/v2/buckets/BUCKET_ID/owners \ --header "Authorization: Token INFLUX_API_TOKEN" \ --header "Accept: application/json" \ --header "Content-Type: application/json" \ --data '{ "id": "09cfb87051cbe000" } /api/v2/buckets/{bucketID}/owners/{userID}: delete: description: > Removes an owner from a bucket. Use this endpoint to remove a user's `owner` role for a bucket. InfluxDB 3 Cloud Serverless uses `/api/v2/authorizations` to assign resource permissions; doesn't use `owner` and `member` roles. #### Limitations - Owner permissions are separate from API token permissions. - Owner permissions are used in the context of the InfluxDB UI. #### Required permissions - `write-orgs INFLUX_ORG_ID` *`INFLUX_ORG_ID`* is the ID of the organization that you want to remove an owner from. #### Related endpoints - Authorizations (API tokens) #### Related guides - [Manage users](https://docs.influxdata.com/influxdb3/cloud-serverless/users/) operationId: DeleteBucketsIDOwnersID parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the owner to remove. in: path name: userID required: true schema: type: string - description: | The ID of the bucket to remove an owner from. in: path name: bucketID required: true schema: type: string responses: '204': description: | Success. The user is no longer an owner of the bucket. '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Remove an owner from a bucket tags: - Buckets /api/v2/dbrps: get: description: | Lists database retention policy (DBRP) mappings. operationId: GetDBRPs parameters: - $ref: '#/components/parameters/TraceSpan' - description: | An organization ID. Only returns DBRP mappings for the specified organization. in: query name: orgID schema: type: string - description: | An organization name. Only returns DBRP mappings for the specified organization. in: query name: org schema: type: string - description: | A DBPR mapping ID. Only returns the specified DBRP mapping. in: query name: id schema: type: string - description: | A bucket ID. Only returns DBRP mappings that belong to the specified bucket. in: query name: bucketID schema: type: string - description: Specifies filtering on default in: query name: default schema: type: boolean - description: | A database. Only returns DBRP mappings that belong to the 1.x database. in: query name: db schema: type: string - description: > A [retention policy](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#retention-policy-rp). Specifies the 1.x retention policy to filter on. in: query name: rp schema: type: string responses: '200': content: application/json: examples: successResponse: value: content: - bucketID: 4d4d9d5b61dee751 database: example_database_1 default: true id: 0a3cbb5dd526a000 orgID: bea7ea952287f70d retention_policy: autogen - bucketID: 4d4d9d5b61dee751 database: example_database_2 default: false id: 0a3cbcde20e38000 orgID: bea7ea952287f70d retention_policy: example_retention_policy schema: $ref: '#/components/schemas/DBRPs' description: >- Success. The response body contains a list of database retention policy mappings. '400': content: application/json: examples: invalidRequest: description: | The query parameters contain invalid values. value: code: invalid message: invalid ID schema: $ref: '#/components/schemas/Error' description: Bad request. The request has one or more invalid parameters. '401': $ref: '#/components/responses/AuthorizationError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: List database retention policy mappings tags: - DBRPs post: description: > Creates a database retention policy (DBRP) mapping and returns the mapping. Use this endpoint to add InfluxDB 1.x API compatibility to your InfluxDB Cloud or InfluxDB OSS 2.x buckets. Your buckets must contain a DBRP mapping in order to query and write using the InfluxDB 1.x API. object. operationId: PostDBRP parameters: - $ref: '#/components/parameters/TraceSpan' requestBody: content: application/json: schema: $ref: '#/components/schemas/DBRPCreate' description: > The database retention policy mapping to add. Note that _`retention_policy`_ is a required parameter in the request body. The value of _`retention_policy`_ can be any arbitrary `string` name or value, with the default value commonly set as `autogen`. The value of _`retention_policy`_ isn't a [retention_policy](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#retention-policy-rp) required: true responses: '201': content: application/json: examples: successResponse: value: bucketID: 4d4d9d5b61dee751 database: example_database default: true id: 0a3cbb5dd526a000 orgID: bea7ea952287f70d retention_policy: autogen schema: $ref: '#/components/schemas/DBRP' description: >- Created. The response body contains the database retention policy mapping. '400': content: application/json: examples: invalidRequest: description: | The query parameters contain invalid values. value: code: invalid message: invalid ID schema: $ref: '#/components/schemas/Error' description: Bad request. The mapping in the request has one or more invalid IDs. '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Add a database retention policy mapping tags: - DBRPs x-codeSamples: - label: 'cURL: create a database retention policy mapping' lang: Shell source: | curl --request POST \ "http://localhost:8086/api/v2/dbrp/" \ --header 'Content-type: application/json' \ --header "Authorization: Token INFLUXDB_TOKEN" \ --data-binary @- << EOF { \ "bucketID": "INFLUXDB_BUCKET_ID", \ "orgID": "INFLUXDB_ORG_ID", \ "database": "database_name", \ "default": true, \ "retention_policy": "example_retention_policy_name" \ } EOF /api/v2/dbrps/{dbrpID}: delete: description: | Deletes the specified database retention policy (DBRP) mapping. operationId: DeleteDBRPID parameters: - $ref: '#/components/parameters/TraceSpan' - description: | An organization ID. Specifies the organization that owns the DBRP mapping. in: query name: orgID schema: type: string - description: | An organization name. Specifies the organization that owns the DBRP mapping. in: query name: org schema: type: string - description: | A DBRP mapping ID. Only returns the specified DBRP mapping. in: path name: dbrpID required: true schema: type: string responses: '204': description: Success. The delete is accepted. '400': content: application/json: examples: invalidRequest: description: | The query parameters contain invalid values. value: code: invalid message: invalid ID schema: $ref: '#/components/schemas/Error' description: Bad Request. Query parameters contain invalid values. '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Delete a database retention policy tags: - DBRPs get: description: | Retrieves the specified retention policy (DBRP) mapping. operationId: GetDBRPsID parameters: - $ref: '#/components/parameters/TraceSpan' - description: | An organization ID. Specifies the organization that owns the DBRP mapping. in: query name: orgID schema: type: string - description: | An organization name. Specifies the organization that owns the DBRP mapping. in: query name: org schema: type: string - description: | A DBRP mapping ID. Specifies the DBRP mapping. in: path name: dbrpID required: true schema: type: string responses: '200': content: application/json: examples: successResponse: value: content: bucketID: 4d4d9d5b61dee751 database: example_database_1 default: true id: 0a3cbb5dd526a000 orgID: bea7ea952287f70d retention_policy: autogen schema: $ref: '#/components/schemas/DBRPGet' description: Success. The response body contains the DBRP mapping. '400': content: application/json: examples: invalidRequest: description: | The query parameters contain invalid values. value: code: invalid message: invalid ID schema: $ref: '#/components/schemas/Error' description: Bad Request. Query parameters contain invalid values. '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Retrieve a database retention policy mapping tags: - DBRPs patch: operationId: PatchDBRPID parameters: - $ref: '#/components/parameters/TraceSpan' - description: | An organization ID. Specifies the organization that owns the DBRP mapping. in: query name: orgID schema: type: string - description: | An organization name. Specifies the organization that owns the DBRP mapping. in: query name: org schema: type: string - description: | A DBRP mapping ID. Specifies the DBRP mapping. in: path name: dbrpID required: true schema: type: string requestBody: content: application/json: schema: $ref: '#/components/schemas/DBRPUpdate' description: > Updates the database retention policy (DBRP) mapping and returns the mapping. Use this endpoint to modify the _retention policy_ (`retention_policy` property) of a DBRP mapping. required: true responses: '200': content: application/json: examples: successResponse: value: content: bucketID: 4d4d9d5b61dee751 database: example_database default: false id: 0a3cbb5dd526a000 orgID: bea7ea952287f70d retention_policy: example_retention_policy schema: $ref: '#/components/schemas/DBRPGet' description: An updated mapping '400': content: application/json: examples: invalidRequest: description: | The query parameters contain invalid values. value: code: invalid message: invalid ID schema: $ref: '#/components/schemas/Error' description: Bad Request. Query parameters contain invalid values. '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Update a database retention policy mapping tags: - DBRPs x-codeSamples: - label: 'cURL: Update a DBRP mapping' lang: Shell source: | curl --request PATCH \ "http://localhost:8086/api/v2/dbrp/DBRP_ID" \ --header 'Content-type: application/json' \ --header "Authorization: Token INFLUX_API_TOKEN" \ --data-binary @- << EOF { "default": true, "retention_policy": "example_retention_policy_name" } EOF /api/v2/orgs: get: description: > Lists [organizations](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#organization/). InfluxDB 3 Cloud Serverless only returns the organization that owns the token passed in the request. operationId: GetOrgs parameters: - $ref: '#/components/parameters/TraceSpan' - $ref: '#/components/parameters/Offset' - $ref: '#/components/parameters/Limit' - $ref: '#/components/parameters/Descending' - description: | An organization name. Only returns the specified organization. in: query name: org schema: type: string - description: | An organization ID. Only returns the specified organization. in: query name: orgID schema: type: string - description: > A user ID. Only returns organizations where the specified user is a member or owner. in: query name: userID schema: type: string responses: '200': content: application/json: examples: successResponse: value: links: self: /api/v2/orgs orgs: - createdAt: '2022-07-17T23:00:30.778487Z' description: Example InfluxDB organization id: INFLUX_ORG_ID links: buckets: /api/v2/buckets?org=INFLUX_ORG dashboards: /api/v2/dashboards?org=INFLUX_ORG labels: /api/v2/orgs/INFLUX_ORG_ID/labels logs: /api/v2/orgs/INFLUX_ORG_ID/logs members: /api/v2/orgs/INFLUX_ORG_ID/members owners: /api/v2/orgs/INFLUX_ORG_ID/owners secrets: /api/v2/orgs/INFLUX_ORG_ID/secrets self: /api/v2/orgs/INFLUX_ORG_ID tasks: /api/v2/tasks?org=InfluxData name: INFLUX_ORG updatedAt: '2022-07-17T23:00:30.778487Z' schema: $ref: '#/components/schemas/Organizations' description: Success. The response body contains a list of organizations. '400': $ref: '#/components/responses/BadRequestError' '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: $ref: '#/components/responses/GeneralServerError' summary: List organizations tags: - Organizations post: description: > Creates an [organization](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#organization) and returns the newly created organization. InfluxDB 3 Cloud Serverless doesn't allow you to use this endpoint to create organizations. #### Related guides - [Manage organizations](https://docs.influxdata.com/influxdb3/cloud-serverless/organizations) operationId: PostOrgs parameters: - $ref: '#/components/parameters/TraceSpan' requestBody: content: application/json: schema: $ref: '#/components/schemas/PostOrganizationRequest' description: The organization to create. required: true responses: '201': content: application/json: examples: successResponse: value: createdAt: '2022-08-24T23:05:52.881317Z' description: '' id: INFLUX_ORG_ID links: buckets: /api/v2/buckets?org=INFLUX_ORG dashboards: /api/v2/dashboards?org=INFLUX_ORG labels: /api/v2/orgs/INFLUX_ORG_ID/labels logs: /api/v2/orgs/INFLUX_ORG_ID/logs members: /api/v2/orgs/INFLUX_ORG_ID/members owners: /api/v2/orgs/INFLUX_ORG_ID/owners secrets: /api/v2/orgs/INFLUX_ORG_ID/secrets self: /api/v2/orgs/INFLUX_ORG_ID tasks: /api/v2/tasks?org=INFLUX_ORG name: INFLUX_ORG updatedAt: '2022-08-24T23:05:52.881318Z' schema: $ref: '#/components/schemas/Organization' description: Created. The response body contains the organization information. '400': $ref: '#/components/responses/BadRequestError' examples: invalidRequest: summary: The `name` field is missing from the request body. value: code: invalid message: org name is empty '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Create an organization tags: - Organizations x-codeSamples: - label: cURL lang: Shell source: | curl --request POST "http://localhost:8086/api/v2/orgs \ --header "Authorization: Token INFLUX_API_TOKEN" \ --header "Accept: application/json" \ --header "Content-Type: application/json" \ --data '{ "name": "INFLUX_ORG", "description: "Example InfluxDB organization" }' /api/v2/orgs/{orgID}: delete: description: > Deletes an organization. Deleting an organization from InfluxDB Cloud can't be undone. Once deleted, all data associated with the organization is removed. #### InfluxDB Cloud - Does the following when you send a delete request: 1. Validates the request and queues the delete. 2. Returns an HTTP `204` status code if queued; _error_ otherwise. 3. Handles the delete asynchronously. #### Limitations - Only one organization can be deleted per request. #### Related guides - [Delete organizations](https://docs.influxdata.com/influxdb3/cloud-serverless/organizations/delete-orgs/) operationId: DeleteOrgsID parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the organization to delete. in: path name: orgID required: true schema: type: string responses: '204': description: | Success. #### InfluxDB Cloud - The organization is queued for deletion. '400': $ref: '#/components/responses/BadRequestError' '401': $ref: '#/components/responses/AuthorizationError' '404': content: application/json: examples: notFound: summary: | The requested organization was not found. value: code: not found message: org not found schema: $ref: '#/components/schemas/Error' description: | Not found. InfluxDB can't find the organization. '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Delete an organization tags: - Organizations get: description: > Retrieves an organization. Use this endpoint to retrieve information for a specific organization. #### Related guides - [View organizations](https://docs.influxdata.com/influxdb3/cloud-serverless/admin/organizations/view-orgs/) operationId: GetOrgsID parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the organization to retrieve. in: path name: orgID required: true schema: type: string responses: '200': content: application/json: schema: $ref: '#/components/schemas/Organization' description: | Success. The response body contains the organization information. '401': $ref: '#/components/responses/AuthorizationError' '404': content: application/json: examples: notFound: summary: | The requested organization wasn't found. value: code: not found message: organization not found schema: $ref: '#/components/schemas/Error' description: | Not found. Organization not found. '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Retrieve an organization tags: - Organizations patch: description: > Updates an organization. Use this endpoint to update properties (`name`, `description`) of an organization. Updating an organization’s name affects all resources that reference the organization by name, including the following: - Queries - Dashboards - Tasks - Telegraf configurations - Templates If you change an organization name, be sure to update the organization name in these resources as well. #### Related Guides - [Update an organization](https://docs.influxdata.com/influxdb3/cloud-serverless/organizations/update-org/) operationId: PatchOrgsID parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the organization to update. in: path name: orgID required: true schema: type: string requestBody: content: application/json: schema: $ref: '#/components/schemas/PatchOrganizationRequest' description: The organization update to apply. required: true responses: '200': content: application/json: schema: $ref: '#/components/schemas/Organization' description: Success. The response body contains the updated organization. '400': $ref: '#/components/responses/BadRequestError' '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Update an organization tags: - Organizations /api/v2/orgs/{orgID}/limits: get: operationId: GetOrgLimitsID parameters: - description: The ID of the organization. in: path name: orgID required: true schema: type: string responses: '200': content: application/json: schema: description: These are org limits similar to those configured in/by quartz. properties: limits: $ref: '#/components/schemas/Limit' links: $ref: '#/components/schemas/Links' type: object description: Limits defined for the organization. default: $ref: '#/components/responses/GeneralServerError' description: unexpected error summary: Retrieve limits for an organization tags: - Limits /api/v2/orgs/{orgID}/members: get: description: | Lists all users that belong to an organization. InfluxDB 3 Cloud Serverless doesn't use `owner` and `member` roles. Use `/api/v2/authorizations` to manage resource permissions. operationId: GetOrgsIDMembers parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the organization to retrieve users for. in: path name: orgID required: true schema: type: string responses: '200': content: application/json: examples: successResponse: value: links: self: /api/v2/orgs/055aa4783aa38398/members users: - id: 791df274afd48a83 links: self: /api/v2/users/791df274afd48a83 name: example_user_1 role: member status: active - id: 09cfb87051cbe000 links: self: /api/v2/users/09cfb87051cbe000 name: example_user_2 role: owner status: active schema: $ref: '#/components/schemas/ResourceMembers' description: > Success. The response body contains a list of all users within the organization. '400': $ref: '#/components/responses/BadRequestError' '401': $ref: '#/components/responses/AuthorizationError' '404': content: application/json: examples: notFound: summary: | The requested organization wasn't found. value: code: not found message: 404 page not found schema: $ref: '#/components/schemas/Error' description: | Not found. InfluxDB can't find the organization. '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: List all members of an organization tags: - Organizations post: description: | Add a user to an organization. InfluxDB 3 Cloud Serverless doesn't use `owner` and `member` roles. Use `/api/v2/authorizations` to manage resource permissions. operationId: PostOrgsIDMembers parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the organization. in: path name: orgID required: true schema: type: string requestBody: content: application/json: schema: $ref: '#/components/schemas/AddResourceMemberRequestBody' description: | The user to add to the organization. required: true responses: '201': content: application/json: examples: successResponse: value: id: 09cfb87051cbe000 links: self: /api/v2/users/09cfb87051cbe000 name: example_user_1 role: member status: active schema: $ref: '#/components/schemas/ResourceMember' description: | Success. The response body contains the user information. '400': $ref: '#/components/responses/BadRequestError' examples: invalidRequest: summary: The user `id` is missing from the request body. value: code: invalid message: user id missing or invalid '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Add a member to an organization tags: - Organizations x-codeSamples: - label: cURL lang: Shell source: > curl --request POST "http://localhost:8086/api/v2/orgs/INFLUX_ORG_ID/members \ --header "Authorization: Token INFLUX_API_TOKEN" \ --header "Accept: application/json" \ --header "Content-Type: application/json" \ --data '{ "id": "09cfb87051cbe000" }' /api/v2/orgs/{orgID}/members/{userID}: delete: description: | Removes a member from an organization. InfluxDB 3 Cloud Serverless doesn't use `owner` and `member` roles. Use `/api/v2/authorizations` to manage resource permissions. operationId: DeleteOrgsIDMembersID parameters: - $ref: '#/components/parameters/TraceSpan' - description: The ID of the user to remove. in: path name: userID required: true schema: type: string - description: The ID of the organization to remove a user from. in: path name: orgID required: true schema: type: string responses: '204': description: | Success. The user is no longer a member of the organization. '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Remove a member from an organization tags: - Organizations /api/v2/orgs/{orgID}/owners: get: description: | Lists all owners of an organization. InfluxDB 3 Cloud Serverless doesn't use `owner` and `member` roles. Use `/api/v2/authorizations` to manage resource permissions. operationId: GetOrgsIDOwners parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The ID of the organization to list owners for. in: path name: orgID required: true schema: type: string responses: '200': content: application/json: examples: successResponse: value: links: self: /api/v2/orgs/055aa4783aa38398/owners users: - id: 09cfb87051cbe000 links: self: /api/v2/users/09cfb87051cbe000 name: example_user_2 role: owner status: active schema: $ref: '#/components/schemas/ResourceOwners' description: A list of organization owners '404': content: application/json: schema: $ref: '#/components/schemas/Error' description: Organization not found default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: List all owners of an organization tags: - Organizations post: description: | Adds an owner to an organization. InfluxDB 3 Cloud Serverless doesn't use `owner` and `member` roles. Use `/api/v2/authorizations` to manage resource permissions. operationId: PostOrgsIDOwners parameters: - $ref: '#/components/parameters/TraceSpan' - description: The ID of the organization that you want to add an owner for. in: path name: orgID required: true schema: type: string requestBody: content: application/json: examples: successResponse: value: id: 09cfb87051cbe000 links: self: /api/v2/users/09cfb87051cbe000 name: example_user_1 role: owner status: active schema: $ref: '#/components/schemas/AddResourceMemberRequestBody' description: The user to add as an owner of the organization. required: true responses: '201': content: application/json: schema: $ref: '#/components/schemas/ResourceOwner' description: | Success. The user is an owner of the organization. The response body contains the owner with role and user detail. '400': $ref: '#/components/responses/BadRequestError' '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Add an owner to an organization tags: - Organizations x-codeSamples: - label: cURL lang: Shell source: > curl --request POST "http://localhost:8086/api/v2/orgs/INFLUX_ORG_ID/owners \ --header "Authorization: Token INFLUX_API_TOKEN" \ --header "Accept: application/json" \ --header "Content-Type: application/json" \ --data '{ "id": "09cfb87051cbe000" }' /api/v2/orgs/{orgID}/owners/{userID}: delete: description: > Removes an [owner](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#owner) from the organization. InfluxDB 3 Cloud Serverless doesn't use `owner` and `member` roles. Use `/api/v2/authorizations` to manage resource permissions. operationId: DeleteOrgsIDOwnersID parameters: - $ref: '#/components/parameters/TraceSpan' - description: The ID of the user to remove. in: path name: userID required: true schema: type: string - description: | The ID of the organization to remove an owner from. in: path name: orgID required: true schema: type: string responses: '204': description: | Success. The user is no longer an owner of the organization. '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '500': $ref: '#/components/responses/InternalServerError' default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Unexpected error summary: Remove an owner from an organization tags: - Organizations /api/v2/orgs/{orgID}/usage: get: operationId: GetOrgUsageID parameters: - description: The ID of the organization. in: path name: orgID required: true schema: type: string - description: > Earliest time ([unix timestamp format](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#unix-timestamp)) to include in results. in: query name: start required: true schema: format: unix timestamp type: integer - description: > Latest time ([unix timestamp format](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#unix-timestamp)) to include in results. in: query name: stop required: false schema: format: unix timestamp type: integer - description: return raw usage data in: query name: raw required: false schema: default: false type: boolean responses: '200': content: text/csv: schema: example: > #group,false,false,true,true,false,false,true,true,true,true #datatype,string,long,dateTime:RFC3339,dateTime:RFC3339,dateTime:RFC3339,double,string,string,string,string #default,_result,,,,,,,,, ,result,table,_start,_stop,_time,_value,_field,_measurement,bucket_id,org_id ,,0,2021-05-10T14:25:10.865702397Z,2021-05-10T15:25:10.865702397Z,2021-05-10T15:00:00Z,5434066,gauge,storage_usage_bucket_bytes,2f6ba0cf9a2fdcbb,cec6fc1d2176dc11 ,,1,2021-05-10T14:25:10.865702397Z,2021-05-10T15:25:10.865702397Z,2021-05-10T15:00:00Z,9924053.966666665,gauge,storage_usage_bucket_bytes,8af67bcaf69d9daf,cec6fc1d2176dc11 type: string description: Usage data headers: Content-Encoding: description: >- Lists any encodings (usually compression algorithms) that have been applied to the response payload. schema: default: identity description: >- The content coding. `gzip` for compressed data or `identity` for unmodified, uncompressed data. enum: - gzip - identity type: string default: $ref: '#/components/responses/GeneralServerError' description: unexpected error summary: Retrieve usage for an organization tags: - Usage /api/v2/write: post: description: > Writes data to a bucket. Use this endpoint to send data in [line protocol](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/syntax/line-protocol/) format to InfluxDB. InfluxDB 3 Cloud Serverless does the following when you send a write request: 1. Validates the request. 2. If successful, attempts to [ingest data](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/internals/durability/#data-ingest) from the request body; otherwise, responds with an [error status](https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/troubleshoot/#review-http-status-codes). 3. Ingests or rejects data in the batch and returns one of the following HTTP status codes: - `204 No Content`: All data in the batch is ingested. - `400 Bad Request`: Data from the batch was rejected and not written. The response body indicates if a partial write occurred. The response body contains error details about [rejected points](https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/troubleshoot/#troubleshoot-rejected-points), up to 100 points. Writes are synchronous--the response status indicates the final status of the write and all ingested data is queryable. To ensure that InfluxDB handles writes in the order you request them, wait for the response before you send the next request. #### Write endpoints The `/write` and `/api/v2/write` endpoints are functionally equivalent for writing data to InfluxDB Cloud Serverless. - Use the `/write` endpoint for [InfluxDB v1 parameter compatibility](https://docs.influxdata.com/influxdb3/cloud-serverless/guides/api-compatibility/v1/). - Use `/api/v2/write` endpoint for [InfluxDB v2 parameter compatibility](https://docs.influxdata.com/influxdb3/cloud-serverless/guides/api-compatibility/v2/). #### Rate limits _Write_ rate limits apply. For more information, see [limits and adjustable quotas](https://docs.influxdata.com/influxdb3/cloud-serverless/admin/billing/limits/). #### Related guides - [Get started writing data](https://docs.influxdata.com/influxdb3/cloud-serverless/get-started/write/) - [Write data with the InfluxDB API](https://docs.influxdata.com/influxdb3/cloud-serverless/get-started/write/) - [Best practices for writing data](https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/best-practices/) - [Troubleshoot issues writing data](https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/troubleshoot/) operationId: PostWrite parameters: - $ref: '#/components/parameters/TraceSpan' - description: | The compression applied to the line protocol in the request payload. To send a gzip payload, pass `Content-Encoding: gzip` header. in: header name: Content-Encoding schema: default: identity description: > Content coding. Use `gzip` for compressed data or `identity` for unmodified, uncompressed data. enum: - gzip - identity type: string - description: > The format of the data in the request body. To send a line protocol payload, pass `Content-Type: text/plain; charset=utf-8`. in: header name: Content-Type schema: default: text/plain; charset=utf-8 description: > `text/plain` is the content type for line protocol. `UTF-8` is the default character set. enum: - text/plain - text/plain; charset=utf-8 type: string - description: | The size of the entity-body, in bytes, sent to InfluxDB. If the length is greater than the `max body` configuration option, the server responds with status code `413`. in: header name: Content-Length schema: description: The length in decimal number of octets. type: integer - description: > The content type that the client can understand. Writes only return a response body if they fail--for example, due to a formatting problem or quota limit. #### InfluxDB 3 Cloud Serverless - Returns only `application/json` for format and limit errors. - Returns only `text/html` for some quota limit errors. #### Related guides - [Troubleshoot issues writing data](https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/troubleshoot/) in: header name: Accept schema: default: application/json description: Error content type. enum: - application/json type: string - description: > An organization name or ID. InfluxDB 3 Cloud Serverless writes data to the bucket in the organization associated with the authorization (API token); doesn't use the `org` parameter or `orgID` parameter. in: query name: org required: true schema: description: The organization name or ID. type: string - description: > An organization ID. InfluxDB 3 Cloud Serverless writes data to the bucket in the organization associated with the authorization (API token); doesn't use the `org` parameter or `orgID` parameter. in: query name: orgID schema: type: string - description: | A bucket name or ID. InfluxDB writes all points in the batch to the specified bucket. in: query name: bucket required: true schema: description: The bucket name or ID. type: string - description: The precision for unix timestamps in the line protocol batch. in: query name: precision schema: $ref: '#/components/schemas/WritePrecision' requestBody: content: text/plain: examples: plain-utf8: value: > airSensors,sensor_id=TLM0201 temperature=73.97038159354763,humidity=35.23103248356096,co=0.48445310567793615 1630424257000000000 airSensors,sensor_id=TLM0202 temperature=75.30007505999716,humidity=35.651929918691714,co=0.5141876544505826 1630424257000000000 schema: format: byte type: string description: > In the request body, provide data in [line protocol format](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/syntax/line-protocol/). To send compressed data, do the following: 1. Use [gzip](https://www.gzip.org/) to compress the line protocol data. 2. In your request, send the compressed data and the `Content-Encoding: gzip` header. #### Related guides - [Best practices for optimizing writes](https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/best-practices/optimize-writes/) required: true responses: '204': description: >- Success ("No Content"). All data in the batch is written and queryable. '400': description: > Data from the batch was rejected and not written. The response body indicates if a partial write occurred or all data was rejected. If a partial write occurred, then some points from the batch are written and queryable. The response body contains details about the [rejected points](https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/troubleshoot/#troubleshoot-rejected-points), up to 100 points. content: application/json: examples: rejectedAllPoints: summary: Rejected all points value: code: invalid line: 2 message: >- no data written, errors encountered on line(s): error message for first rejected point error message for second rejected point error message for Nth rejected point (up to 100 rejected points) partialWriteErrorWithRejectedPoints: summary: Partial write rejects some points value: code: invalid line: 2 message: >- partial write has occurred, errors encountered on line(s): error message for first rejected point error message for second rejected point error message for Nth rejected point (up to 100 rejected points) schema: $ref: '#/components/schemas/LineProtocolError' '401': $ref: '#/components/responses/AuthorizationError' '404': $ref: '#/components/responses/ResourceNotFoundError' '413': content: application/json: examples: dataExceedsSizeLimitOSS: summary: InfluxDB OSS response value: > {"code":"request too large","message":"unable to read data: points batch is too large"} schema: $ref: '#/components/schemas/LineProtocolLengthError' text/html: examples: dataExceedsSizeLimit: summary: InfluxDB Cloud response value: | 413 Request Entity Too Large

413 Request Entity Too Large


nginx
schema: type: string description: > The request payload is too large. InfluxDB rejected the batch and did not write any data. InfluxDB returns this error if the payload exceeds the 50MB size limit or all data is outside the retention window. '429': description: | Too many requests. #### InfluxDB Cloud - Returns this error if a **read** or **write** request exceeds your plan's [adjustable service quotas](https://docs.influxdata.com/influxdb3/cloud-serverless/account-management/limits/#adjustable-service-quotas) or if a **delete** request exceeds the maximum [global limit](https://docs.influxdata.com/influxdb3/cloud-serverless/account-management/limits/#global-limits). - For rate limits that reset automatically, returns a `Retry-After` header that describes when to try the write again. - For limits that can't reset (for example, **cardinality limit**), doesn't return a `Retry-After` header. Rates (data-in (writes), queries (reads), and deletes) accrue within a fixed five-minute window. Once a rate limit is exceeded, InfluxDB returns an error response until the current five-minute window resets. headers: Retry-After: description: >- Non-negative decimal integer indicating seconds to wait before retrying the request. schema: format: int32 type: integer '500': $ref: '#/components/responses/InternalServerError' '503': description: > Service unavailable. - Returns this error if the server is temporarily unavailable to accept writes. - Returns a `Retry-After` header that describes when to try the write again. headers: Retry-After: description: >- Non-negative decimal integer indicating seconds to wait before retrying the request. schema: format: int32 type: integer default: $ref: '#/components/responses/GeneralServerError' summary: Write data using the InfluxDB v2 HTTP API tags: - Write data /query: get: description: > Queries InfluxDB using InfluxQL with InfluxDB v1 request and response formats. #### Related guides - [Use the InfluxDB v1 HTTP API](https://docs.influxdata.com/influxdb3/cloud-serverless/guides/api-compatibility/v1/) - [Query data](https://docs.influxdata.com/influxdb3/cloud-serverless/query-data/) operationId: GetLegacyQuery parameters: - $ref: '#/components/parameters/TraceSpan' - in: header name: Accept schema: default: application/json description: > Media type that the client can understand. **Note**: With `application/csv`, query results include [**unix timestamps**](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#unix-timestamp) instead of [RFC3339 timestamps](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#rfc3339-timestamp). enum: - application/json - application/csv - text/csv - application/x-msgpack type: string - description: >- The content encoding (usually a compression algorithm) that the client can understand. in: header name: Accept-Encoding schema: default: identity description: >- The content coding. Use `gzip` for compressed data or `identity` for unmodified, uncompressed data. enum: - gzip - identity type: string - in: header name: Content-Type schema: enum: - application/json type: string - description: The InfluxDB 1.x username to authenticate the request. in: query name: u schema: type: string - description: The InfluxDB 1.x password to authenticate the request. in: query name: p schema: type: string - description: > The database to query data from. This is mapped to an InfluxDB [bucket](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#bucket). For more information, see [Database and retention policy mapping](https://docs.influxdata.com/influxdb/cloud/reference/api/influxdb-1x/dbrp/). in: query name: db required: true schema: type: string - description: > The retention policy to query data from. This is mapped to an InfluxDB [bucket](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#bucket). For more information, see [Database and retention policy mapping](https://docs.influxdata.com/influxdb/cloud/reference/api/influxdb-1x/dbrp/). in: query name: rp schema: type: string - description: >- The InfluxQL query to execute. To execute multiple queries, delimit queries with a semicolon (`;`). in: query name: q required: true schema: type: string - description: > A unix timestamp precision. Formats timestamps as [unix (epoch) timestamps](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#unix-timestamp) with the specified precision instead of [RFC3339 timestamps](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/glossary/#rfc3339-timestamp) with nanosecond precision. in: query name: epoch schema: enum: - ns - u - µ - ms - s - m - h type: string responses: '200': content: application/csv: schema: $ref: '#/components/schemas/InfluxqlCsvResponse' application/json: schema: $ref: '#/components/schemas/InfluxqlJsonResponse' examples: influxql-chunk_size_2: value: > {"results":[{"statement_id":0,"series":[{"name":"mymeas","columns":["time","myfield","mytag"],"values":[["2016-05-19T18:37:55Z",90,"1"],["2016-05-19T18:37:56Z",90,"1"]],"partial":true}],"partial":true}]} {"results":[{"statement_id":0,"series":[{"name":"mymeas","columns":["time","myfield","mytag"],"values":[["2016-05-19T18:37:57Z",90,"1"],["2016-05-19T18:37:58Z",90,"1"]]}]}]} application/x-msgpack: schema: format: binary type: string text/csv: schema: $ref: '#/components/schemas/InfluxqlCsvResponse' description: > Query results. If a DBRP doesn't exist for the `db=DATABASE_NAME` and `rp=RETENTION_POLICY_NAME` combination in the query request, the response body contains an error message, for example `"database not found:..."`. headers: Content-Encoding: description: >- Lists encodings (usually compression algorithms) that have been applied to the response payload. schema: default: identity description: | The content coding: - `gzip`: compressed data - `identity`: unmodified, uncompressed data. enum: - gzip - identity type: string Trace-Id: description: The trace ID, if generated, of the request. schema: description: Trace ID of a request. type: string '429': description: | #### InfluxDB Cloud: - returns this error if a **read** or **write** request exceeds your plan's [adjustable service quotas](https://docs.influxdata.com/influxdb3/cloud-serverless/account-management/limits/#adjustable-service-quotas) or if a **delete** request exceeds the maximum [global limit](https://docs.influxdata.com/influxdb3/cloud-serverless/account-management/limits/#global-limits) - returns `Retry-After` header that describes when to try the write again. headers: Retry-After: description: >- A non-negative decimal integer indicating the seconds to delay after the response is received. schema: format: int32 type: integer default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Error processing query summary: Query using the InfluxDB v1 HTTP API tags: - Query data /write: post: operationId: PostLegacyWrite description: > Writes data to a bucket. Use this endpoint for [InfluxDB v1 parameter compatibility](https://docs.influxdata.com/influxdb3/cloud-serverless/guides/api-compatibility/v1/) when sending data in [line protocol](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/syntax/line-protocol/) format to InfluxDB. InfluxDB 3 Cloud Serverless does the following when you send a write request: 1. Validates the request. 2. If successful, attempts to [ingest data](https://docs.influxdata.com/influxdb3/cloud-serverless/reference/internals/durability/#data-ingest) from the request body; otherwise, responds with an [error status](https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/troubleshoot/#review-http-status-codes). 3. Ingests or rejects data in the batch and returns one of the following HTTP status codes: - `204 No Content`: all data in the batch is ingested - `201 Created`: some points in the batch are ingested and queryable, and some points are rejected - `400 Bad Request`: all data is rejected The response body contains error details about [rejected points](https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/troubleshoot/#troubleshoot-rejected-points), up to 100 points. Writes are synchronous--the response status indicates the final status of the write and all ingested data is queryable. To ensure that InfluxDB handles writes in the order you request them, wait for the response before you send the next request. #### Write endpoints The `/write` and `/api/v2/write` endpoints are functionally equivalent for writing data to InfluxDB Cloud Serverless. - Use the `/write` endpoint for [InfluxDB v1 parameter compatibility](https://docs.influxdata.com/influxdb3/cloud-serverless/guides/api-compatibility/v1/). - Use `/api/v2/write` endpoint for [InfluxDB v2 parameter compatibility](https://docs.influxdata.com/influxdb3/cloud-serverless/guides/api-compatibility/v2/). #### Rate limits _Write_ rate limits apply. For more information, see [limits and adjustable quotas](https://docs.influxdata.com/influxdb3/cloud-serverless/admin/billing/limits/). #### Related guides - [Write data with the InfluxDB API](https://docs.influxdata.com/influxdb3/cloud-serverless/get-started/write/) - [Optimize writes to InfluxDB](https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/best-practices/optimize-writes/) - [Troubleshoot issues writing data](https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/troubleshoot/) parameters: - $ref: '#/components/parameters/TraceSpan' - description: The InfluxDB 1.x username to authenticate the request. in: query name: u schema: type: string - description: The InfluxDB 1.x password to authenticate the request. in: query name: p schema: type: string - description: >- Bucket to write to. If none exists, InfluxDB creates a bucket with a default 3-day retention policy. in: query name: db required: true schema: type: string - description: Retention policy name. in: query name: rp schema: type: string - description: Write precision. in: query name: precision schema: type: string - description: >- When present, indicates that compression is applied to the line protocol body. in: header name: Content-Encoding schema: default: identity description: >- Specifies that the line protocol in the body is encoded with gzip or not encoded with identity. enum: - gzip - identity type: string requestBody: content: text/plain: schema: type: string description: Line protocol body required: true responses: '201': description: > Success ("Created"). Some points in the batch are written and queryable, and some points are rejected. The response body contains details about the [rejected points](https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/troubleshoot/#troubleshoot-rejected-points), up to 100 points. content: application/json: examples: partialWriteErrorWithRejectedPoints: summary: Partial write rejects points with syntax errors value: code: invalid line: 2 message: >- failed to parse line protocol: errors encountered on line(s): error message for first rejected point error message for second rejected point error message for Nth rejected point (up to 100 rejected points) schema: $ref: '#/components/schemas/LineProtocolError' '204': description: >- Success ("No Content"). All data in the batch is written and queryable. '400': description: > All data in the batch is rejected and not written. The response body contains details about the [rejected points](https://docs.influxdata.com/influxdb3/cloud-serverless/write-data/troubleshoot/#troubleshoot-rejected-points). content: application/json: examples: rejectsAllPoints: summary: Rejected all points value: code: invalid line: 2 message: >- failed to parse line protocol: errors encountered on line(s): error message for first rejected point error message for second rejected point error message for Nth rejected point (up to 100 rejected points) schema: $ref: '#/components/schemas/LineProtocolError' '401': content: application/json: schema: $ref: '#/components/schemas/Error' description: >- Token doesn't have sufficient permissions to write to this organization and bucket or the organization and bucket do not exist. '403': content: application/json: schema: $ref: '#/components/schemas/Error' description: No token was sent and they are required. '413': content: application/json: schema: $ref: '#/components/schemas/LineProtocolLengthError' description: >- Write has been rejected because the payload is too large. Error message returns max size supported. All data in body was rejected and not written. '429': description: >- Token is temporarily over quota. The Retry-After header describes when to try the write again. headers: Retry-After: description: >- A non-negative decimal integer indicating the seconds to delay after the response is received. schema: format: int32 type: integer '503': description: >- Server is temporarily unavailable to accept writes. The Retry-After header describes when to try the write again. headers: Retry-After: description: >- A non-negative decimal integer indicating the seconds to delay after the response is received. schema: format: int32 type: integer default: content: application/json: schema: $ref: '#/components/schemas/Error' description: Internal server error summary: Write data using the InfluxDB v1 HTTP API tags: - Write data components: examples: AuthorizationPostRequest: description: Creates an authorization. summary: An authorization for a resource type value: description: iot_users read buckets orgID: INFLUX_ORG_ID permissions: - action: read resource: type: buckets AuthorizationWithResourcePostRequest: description: Creates an authorization for access to a specific resource. summary: An authorization for a resource value: description: iot_users read buckets orgID: INFLUX_ORG_ID permissions: - action: read resource: id: INFLUX_BUCKET_ID type: buckets AuthorizationWithUserPostRequest: description: Creates an authorization scoped to a specific user. summary: An authorization scoped to a user value: description: iot_user write to bucket orgID: INFLUX_ORG_ID permissions: - action: write resource: id: INFLUX_BUCKET_ID type: buckets userID: INFLUX_USER_ID TaskWithFluxRequest: description: Sets the `flux` property with Flux task options and a query. summary: A task with Flux value: description: >- This task contains Flux that configures the task schedule and downsamples CPU data every hour. flux: "option task = {name: \"CPU Total 1 Hour New\", every: 1h}from(bucket: \"telegraf\") |> range(start: -1h) |> filter(fn: (r) => (r._measurement == \"cpu\")) |> filter(fn: (r) =>\n\t\t(r._field == \"usage_system\")) |> filter(fn: (r) => (r.cpu == \"cpu-total\")) |> aggregateWindow(every: 1h, fn: max) |> to(bucket: \"cpu_usage_user_total_1h\", org: \"INFLUX_ORG\")" status: active TaskWithScriptRequest: description: | Sets properties for a task that runs an _invokable script_. summary: A task with an invokable script value: description: >- This task runs an invokable script every hour with the defined parameters. every: 1h name: CPU Total 1 Hour New scriptID: SCRIPT_ID scriptParameters: bucket: telegraf filterField: cpu-total rangeStart: '-1h' status: active parameters: After: description: | A resource ID to seek from. Returns records created after the specified record; results don't include the specified record. Use `after` instead of the `offset` parameter. For more information about pagination 
[...]
